#define TEMPID1 0x000000401          // EnOceanモジュールhelp1
#define TEMPID2 0x004017C00          // EnOceanモジュールrally1
#define TEMPID3 0x004010142          // EnOceanモジュールrally2
#define TEMPID4 0x0002CB3D1          // EnOceanモジュールIDSW2
#define TEMPID5 0x004001067          // EnOceanモジュールIDMS1
#define TEMPID6 0x004016BB6          // EnOceanモジュールIDMS2
#define SYNC    0x55                 // SYNCバイト
 
void setup()
{
  //Pin 0/1
  Serial.begin(57600);              // 57600-EnOcean Serial Protocol 3
  Serial.println("Working");
  // initialize digital pin 13 as an output.
  pinMode(4, OUTPUT);
  digitalWrite(4, HIGH);   // turn the LED on (HIGH is the voltage level)  
  pinMode(5, OUTPUT);
  digitalWrite(5, HIGH);   // turn the LED on (HIGH is the voltage level)
  pinMode(6, OUTPUT);
  digitalWrite(6, HIGH);   // turn the LED on (HIGH is the voltage level)  
  pinMode(7, OUTPUT);
  digitalWrite(7, HIGH);   // turn the LED on (HIGH is the voltage level)
  pinMode(8, OUTPUT);
  digitalWrite(8, HIGH);   // turn the LED on (HIGH is the voltage level)  
  pinMode(9, OUTPUT);
  digitalWrite(9, HIGH);   // turn the LED on (HIGH is the voltage level)

}
 
void loop()
{
  unsigned char   dataReceive = 0 ;  //受信確認フラグ
  unsigned char   aChar = 0 ;        //データ格納用変数
  unsigned char   pos = 0 ;          //ESPデータ位置
  unsigned long   senderID = 0 ;     //温湿度モジュールのID
  unsigned short  dataLength = 0 ;   //データ長
  unsigned char   optLength = 0 ;    //オプションデータ長
  unsigned char   packettype = 0 ;    //パケットタイプ
  float Temp = 0 ;                 //温度データ
  float Hum = 0 ;                  //湿度データ
  char buf[1] ;
 
  while(Serial.available()>0){    // XOcean受信したか？
    aChar = Serial.read();
    switch(pos){
      case(0):
      if( SYNC == aChar){          // SYNCバイトだったら受信開始
        delay(5);
        pos++;                     // pos移動　SYNC -> dataLength
        dataReceive = 1 ;
      }
      break;
      case(1):
      dataLength = 0x00FF & aChar ;  // dataLength 上位1バイトです。
      pos++;                        // pos移動 dataLength -> dataLength
      break;
      case(2):
      dataLength = (dataLength<<8) + aChar ; // dataLength 下位1バイトです。
      pos++ ;                                // pos移動 dataLength -> optLength
      break;
      case(3):
      optLength = aChar ;          //  optionLength
      pos++ ;                      // pos移動　optLength -> packet type
      break;
      case(4):
      packettype = aChar ;        //   packettype
      pos++;                      // pos移動  packet type -> crc
      break;
      case(5):
      pos++;                      // pos移動　crc -> header
      break;
      case(6):
      pos++;                      // pos移動  header -> ID1
      break;
      case(7):
      senderID =  0x0000FF & aChar ;  // ID1バイト
      pos++;                      // pos移動  ID1 -> ID2
      break;
      case(8):
      case(9):
      case(10):
      senderID =  (senderID<<8) + aChar ;  // ID2-4バイト
      pos++;                      // pos移動  ID2 -> ID4 -> data1
      break;
      case(11):
      pos++;                      // pos移動  data1 -> data2
      break;
      case(12):
      Hum = (float)aChar * 100/250 ;    //  humdata
      pos++;                      // pos移動  data2(hum) -> data3(temp)
      break;
      case(13):
      Temp = (float)aChar * 40/250 ;    //  Tempdata
      pos++;
      break;
    default:
      break;
    }  
 
  }
  if(dataReceive ==1){
    if(TEMPID1 == senderID ){
      Serial.print("POST1=ON");
      Serial.println("");
  digitalWrite(4, LOW);    // turn the LED off by making the voltage LOW
  delay(1500);              // wait for a second
      
      
    }
    if(TEMPID2 == senderID ){
      Serial.print("POST2=ON");
      Serial.println("");
  digitalWrite(6, LOW);    // turn the LED off by making the voltage LOW
  delay(1500);              // wait for a second
    }
    if(TEMPID3 == senderID ){
      Serial.print("PUSH1=ON");
      Serial.println("");
  digitalWrite(5, LOW);    // turn the LED off by making the voltage LOW

  delay(1500);              // wait for a second
    }
    if(TEMPID4 == senderID ){
      Serial.print("PUSH2=ON");
      Serial.println("");
  digitalWrite(7, LOW);    // turn the LED off by making the voltage LOW
  delay(1500);              // wait for a second
    }
    if(TEMPID5 == senderID ){
      Serial.print("MS1=ON");
      Serial.println("");
  digitalWrite(8, LOW);    // turn the LED off by making the voltage LOW
  delay(1500);              // wait for a second
    }
    if(TEMPID6 == senderID ){
      Serial.print("PUSH2=ON");
      Serial.println("");
  digitalWrite(9, LOW);    // turn the LED off by making the voltage LOW
  delay(1500);              // wait for a second
    }    
   
    dataReceive = 0 ;
  }
 {
  digitalWrite(4, HIGH);   // turn the LED on (HIGH is the voltage level)
  digitalWrite(5, HIGH);   // turn the LED on (HIGH is the voltage level)
  digitalWrite(6, HIGH);   // turn the LED on (HIGH is the voltage level)
  digitalWrite(7, HIGH);   // turn the LED on (HIGH is the voltage level)
  digitalWrite(8, HIGH);   // turn the LED on (HIGH is the voltage level)
  digitalWrite(9, HIGH);   // turn the LED on (HIGH is the voltage level)

 }
 
}
